Index: src/analysis_bonds.cpp
===================================================================
--- src/analysis_bonds.cpp	(revision 7ee87fc14c8174aaa7e562acd4b38bbed5239316)
+++ src/analysis_bonds.cpp	(revision 58ed4a7c2bc8ff58164d0438ee813b30de7a34da)
@@ -37,5 +37,5 @@
   }
   if (((int)Mean % 2) != 0)
-    eLog() << Verbose(1) << "Something is wrong with the bond structure, the number of bonds is not even!" << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Something is wrong with the bond structure, the number of bonds is not even!" << endl);
   Mean /= (double)AtomCount;
 };
Index: src/analysis_correlation.cpp
===================================================================
--- src/analysis_correlation.cpp	(revision 7ee87fc14c8174aaa7e562acd4b38bbed5239316)
+++ src/analysis_correlation.cpp	(revision 58ed4a7c2bc8ff58164d0438ee813b30de7a34da)
@@ -36,5 +36,5 @@
 
   if (molecules->ListOfMolecules.empty()) {
-    eLog() << Verbose(1) <<"No molecule given." << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) <<"No molecule given." << endl);
     return outmap;
   }
@@ -42,5 +42,5 @@
   for (MoleculeList::const_iterator MolWalker = molecules->ListOfMolecules.begin(); MolWalker != molecules->ListOfMolecules.end(); MolWalker++)
     if ((*MolWalker)->ActiveFlag) {
-      eLog() << Verbose(2) << "Current molecule is " << *MolWalker << "." << endl;
+      DoeLog(2) && (eLog()<< Verbose(2) << "Current molecule is " << *MolWalker << "." << endl);
       atom *Walker = (*MolWalker)->start;
       while (Walker->next != (*MolWalker)->end) {
@@ -92,5 +92,5 @@
 
   if (molecules->ListOfMolecules.empty()) {
-    eLog() << Verbose(1) <<"No molecule given." << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) <<"No molecule given." << endl);
     return outmap;
   }
@@ -100,5 +100,5 @@
       double * FullMatrix = ReturnFullMatrixforSymmetric(World::get()->cell_size);
       double * FullInverseMatrix = InverseMatrix(FullMatrix);
-      eLog() << Verbose(2) << "Current molecule is " << *MolWalker << "." << endl;
+      DoeLog(2) && (eLog()<< Verbose(2) << "Current molecule is " << *MolWalker << "." << endl);
       atom *Walker = (*MolWalker)->start;
       while (Walker->next != (*MolWalker)->end) {
@@ -257,5 +257,5 @@
 
   if ((Surface == NULL) || (LC == NULL) || (molecules->ListOfMolecules.empty())) {
-    eLog() << Verbose(1) <<"No Tesselation, no LinkedCell or no molecule given." << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) <<"No Tesselation, no LinkedCell or no molecule given." << endl);
     return outmap;
   }
@@ -333,6 +333,7 @@
                 checkX.AddVector(&periodicX);
                 checkX.MatrixMultiplication(FullMatrix);
-                triangle = Surface->FindClosestTriangleToVector(&checkX, LC);
-                distance = Surface->GetDistanceSquaredToTriangle(checkX, triangle);
+                TriangleIntersectionList Intersections(&checkX,Surface,LC);
+                distance = Intersections.GetSmallestDistance();
+                triangle = Intersections.GetClosestTriangle();
                 if ((ShortestDistance == -1.) || (distance < ShortestDistance)) {
                   ShortestDistance = distance;
@@ -341,5 +342,4 @@
               }
           // insert
-          ShortestDistance = sqrt(ShortestDistance);
           outmap->insert ( pair<double, pair<atom *, BoundaryTriangleSet*> >(ShortestDistance, pair<atom *, BoundaryTriangleSet*> (Walker, ShortestTriangle) ) );
           //Log() << Verbose(1) << "INFO: Inserting " << Walker << " with distance " << ShortestDistance << " to " << *ShortestTriangle << "." << endl;
Index: src/analysis_correlation.hpp
===================================================================
--- src/analysis_correlation.hpp	(revision 7ee87fc14c8174aaa7e562acd4b38bbed5239316)
+++ src/analysis_correlation.hpp	(revision 58ed4a7c2bc8ff58164d0438ee813b30de7a34da)
@@ -71,5 +71,5 @@
 
   if (map == NULL) {
-    eLog() << Verbose(0) << "Nothing to min/max, map is NULL!" << endl;
+    DoeLog(0) && (eLog()<< Verbose(0) << "Nothing to min/max, map is NULL!" << endl);
     performCriticalExit();
     return;
@@ -109,5 +109,5 @@
 
   if (map == NULL) {
-    eLog() << Verbose(0) << "Nothing to bin, is NULL!" << endl;
+    DoeLog(0) && (eLog()<< Verbose(0) << "Nothing to bin, is NULL!" << endl);
     performCriticalExit();
     return outmap;
Index: src/analyzer.cpp
===================================================================
--- src/analyzer.cpp	(revision 7ee87fc14c8174aaa7e562acd4b38bbed5239316)
+++ src/analyzer.cpp	(revision 58ed4a7c2bc8ff58164d0438ee813b30de7a34da)
@@ -96,5 +96,5 @@
   if (!Hcorrection.ParseFragmentMatrix(argv[1], "", HCORRECTIONSUFFIX,0,0)) {
     NoHCorrection = true;
-    eLog() << Verbose(2) << "No HCorrection file found, skipping these." << endl;
+    DoeLog(2) && (eLog()<< Verbose(2) << "No HCorrection file found, skipping these." << endl);
   }
   
@@ -102,9 +102,9 @@
   if (!Hessian.ParseFragmentMatrix(argv[1], dir, HessianSuffix,0,0)) {
     NoHessian = true;
-    eLog() << Verbose(2) << "No Hessian file found, skipping these." << endl;
+    DoeLog(2) && (eLog()<< Verbose(2) << "No Hessian file found, skipping these." << endl);
   }
   if (!Time.ParseFragmentMatrix(argv[1], dir, TimeSuffix, 10,1)) {
     NoTime = true;
-    eLog() << Verbose(2) << "No speed file found, skipping these." << endl;
+    DoeLog(2) && (eLog()<< Verbose(2) << "No speed file found, skipping these." << endl);
   }
   if (periode != NULL) { // also look for PAS values
Index: src/atom_bondedparticle.cpp
===================================================================
--- src/atom_bondedparticle.cpp	(revision 7ee87fc14c8174aaa7e562acd4b38bbed5239316)
+++ src/atom_bondedparticle.cpp	(revision 58ed4a7c2bc8ff58164d0438ee813b30de7a34da)
@@ -86,8 +86,8 @@
       status = true;
     } else {
-      eLog() << Verbose(1) << *Binder << " does not contain " << *this << "." << endl;
+      DoeLog(1) && (eLog()<< Verbose(1) << *Binder << " does not contain " << *this << "." << endl);
     }
   } else {
-    eLog() << Verbose(1) << "Binder is " << Binder << "." << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Binder is " << Binder << "." << endl);
   }
   return status;
@@ -105,8 +105,8 @@
       status = true;
     } else {
-      eLog() << Verbose(1) << *Binder << " does not contain " << *this << "." << endl;
+      DoeLog(1) && (eLog()<< Verbose(1) << *Binder << " does not contain " << *this << "." << endl);
     }
   } else {
-    eLog() << Verbose(1) << "Binder is " << Binder << "." << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Binder is " << Binder << "." << endl);
   }
   return status;
@@ -150,5 +150,5 @@
       //Log() << Verbose(2) << "Increased bond degree for bond " << *CandidateBond << "." << endl;
     } else {
-      eLog() << Verbose(2) << "Could not find correct degree for atom " << *this << "." << endl;
+      DoeLog(2) && (eLog()<< Verbose(2) << "Could not find correct degree for atom " << *this << "." << endl);
       FalseBondDegree++;
     }
Index: src/bond.cpp
===================================================================
--- src/bond.cpp	(revision 7ee87fc14c8174aaa7e562acd4b38bbed5239316)
+++ src/bond.cpp	(revision 58ed4a7c2bc8ff58164d0438ee813b30de7a34da)
@@ -63,5 +63,5 @@
   if(rightatom == Atom) 
     return leftatom;
-  eLog() << Verbose(1) << "Bond " << *this << " does not contain atom " << *Atom << "!" << endl;
+  DoeLog(1) && (eLog()<< Verbose(1) << "Bond " << *this << " does not contain atom " << *Atom << "!" << endl);
   return NULL;
 };
@@ -99,5 +99,5 @@
 bool bond::MarkUsed(const enum Shading color) {
   if (Used == black) {
-    eLog() << Verbose(1) << "Bond " << this << " was already marked black!." << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Bond " << this << " was already marked black!." << endl);
     return false;
   } else {
Index: src/bondgraph.cpp
===================================================================
--- src/bondgraph.cpp	(revision 7ee87fc14c8174aaa7e562acd4b38bbed5239316)
+++ src/bondgraph.cpp	(revision 58ed4a7c2bc8ff58164d0438ee813b30de7a34da)
@@ -58,5 +58,5 @@
     Log() << Verbose(1) << "Parsing bond length matrix successful." << endl;
   } else {
-    eLog() << Verbose(1) << "Parsing bond length matrix failed." << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Parsing bond length matrix failed." << endl);
   }
 
@@ -159,5 +159,5 @@
 {
   if (BondLengthMatrix == NULL) {// safety measure if no matrix has been parsed yet
-    eLog() << Verbose(2) << "BondLengthMatrixMinMaxDistance() called without having parsed the bond length matrix yet!" << endl;
+    DoeLog(2) && (eLog()<< Verbose(2) << "BondLengthMatrixMinMaxDistance() called without having parsed the bond length matrix yet!" << endl);
     CovalentMinMaxDistance(Walker, OtherWalker, MinDistance, MaxDistance, IsAngstroem);
   } else {
Index: src/boundary.cpp
===================================================================
--- src/boundary.cpp	(revision 7ee87fc14c8174aaa7e562acd4b38bbed5239316)
+++ src/boundary.cpp	(revision 58ed4a7c2bc8ff58164d0438ee813b30de7a34da)
@@ -342,5 +342,5 @@
     for (Boundaries::iterator runner = BoundaryPoints[axis].begin(); runner != BoundaryPoints[axis].end(); runner++)
         if (!TesselStruct->AddBoundaryPoint(runner->second.second, 0))
-          eLog() << Verbose(2) << "Point " << *(runner->second.second) << " is already present!" << endl;
+          DoeLog(2) && (eLog()<< Verbose(2) << "Point " << *(runner->second.second) << " is already present!" << endl);
 
   Log() << Verbose(0) << "I found " << TesselStruct->PointsOnBoundaryCount << " points on the convex boundary." << endl;
@@ -362,5 +362,5 @@
   // 3c. check whether all atoms lay inside the boundary, if not, add to boundary points, segment triangle into three with the new point
   if (!TesselStruct->InsertStraddlingPoints(mol, LCList))
-    eLog() << Verbose(1) << "Insertion of straddling points failed!" << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Insertion of straddling points failed!" << endl);
 
   Log() << Verbose(0) << "I created " << TesselStruct->TrianglesOnBoundary.size() << " intermediate triangles with " << TesselStruct->LinesOnBoundary.size() << " lines and " << TesselStruct->PointsOnBoundary.size() << " points." << endl;
@@ -401,5 +401,5 @@
         // flip the line
         if (TesselStruct->PickFarthestofTwoBaselines(line) == 0.)
-          eLog() << Verbose(1) << "Correction of concave baselines failed!" << endl;
+          DoeLog(1) && (eLog()<< Verbose(1) << "Correction of concave baselines failed!" << endl);
         else {
           TesselStruct->FlipBaseline(line);
@@ -456,5 +456,5 @@
 
   if ((TesselStruct == NULL) || (TesselStruct->PointsOnBoundary.empty())) {
-    eLog() << Verbose(1) << "TesselStruct is empty." << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "TesselStruct is empty." << endl);
     return false;
   }
@@ -521,5 +521,5 @@
   // check whether there is something to work on
   if (TesselStruct == NULL) {
-    eLog() << Verbose(1) << "TesselStruct is empty!" << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "TesselStruct is empty!" << endl);
     return volume;
   }
@@ -748,5 +748,5 @@
   Log() << Verbose(1) << "Minimum volume of the convex envelope contained in a rectangular box is " << minimumvolume << " atomicmassunit/" << (IsAngstroem ? "angstrom" : "atomiclength") << "^3." << endl;
   if (minimumvolume > cellvolume) {
-    eLog() << Verbose(1) << "the containing box already has a greater volume than the envisaged cell volume!" << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "the containing box already has a greater volume than the envisaged cell volume!" << endl);
     Log() << Verbose(0) << "Setting Box dimensions to minimum possible, the greatest diameters." << endl;
     for (int i = 0; i < NDIM; i++)
Index: src/builder.cpp
===================================================================
--- src/builder.cpp	(revision 7ee87fc14c8174aaa7e562acd4b38bbed5239316)
+++ src/builder.cpp	(revision 58ed4a7c2bc8ff58164d0438ee813b30de7a34da)
@@ -85,22 +85,22 @@
   bool valid;
 
-  Log() << Verbose(0) << "===========ADD ATOM============================" << endl;
-  Log() << Verbose(0) << " a - state absolute coordinates of atom" << endl;
-  Log() << Verbose(0) << " b - state relative coordinates of atom wrt to reference point" << endl;
-  Log() << Verbose(0) << " c - state relative coordinates of atom wrt to already placed atom" << endl;
-  Log() << Verbose(0) << " d - state two atoms, two angles and a distance" << endl;
-  Log() << Verbose(0) << " e - least square distance position to a set of atoms" << endl;
-  Log() << Verbose(0) << "all else - go back" << endl;
-  Log() << Verbose(0) << "===============================================" << endl;
-  Log() << Verbose(0) << "Note: Specifiy angles in degrees not multiples of Pi!" << endl;
-  Log() << Verbose(0) << "INPUT: ";
+  cout << Verbose(0) << "===========ADD ATOM============================" << endl;
+  cout << Verbose(0) << " a - state absolute coordinates of atom" << endl;
+  cout << Verbose(0) << " b - state relative coordinates of atom wrt to reference point" << endl;
+  cout << Verbose(0) << " c - state relative coordinates of atom wrt to already placed atom" << endl;
+  cout << Verbose(0) << " d - state two atoms, two angles and a distance" << endl;
+  cout << Verbose(0) << " e - least square distance position to a set of atoms" << endl;
+  cout << Verbose(0) << "all else - go back" << endl;
+  cout << Verbose(0) << "===============================================" << endl;
+  cout << Verbose(0) << "Note: Specifiy angles in degrees not multiples of Pi!" << endl;
+  cout << Verbose(0) << "INPUT: ";
   cin >> choice;
 
   switch (choice) {
     default:
-      eLog() << Verbose(2) << "Not a valid choice." << endl;
+      DoeLog(2) && (eLog()<< Verbose(2) << "Not a valid choice." << endl);
       break;
       case 'a': // absolute coordinates of atom
-        Log() << Verbose(0) << "Enter absolute coordinates." << endl;
+        cout << Verbose(0) << "Enter absolute coordinates." << endl;
         first = new atom;
         first->x.AskPosition(World::get()->cell_size, false);
@@ -113,11 +113,11 @@
         valid = true;
         do {
-          if (!valid) eLog() << Verbose(2) << "Resulting position out of cell." << endl;
-          Log() << Verbose(0) << "Enter reference coordinates." << endl;
+          if (!valid) DoeLog(2) && (eLog()<< Verbose(2) << "Resulting position out of cell." << endl);
+          cout << Verbose(0) << "Enter reference coordinates." << endl;
           x.AskPosition(World::get()->cell_size, true);
-          Log() << Verbose(0) << "Enter relative coordinates." << endl;
+          cout << Verbose(0) << "Enter relative coordinates." << endl;
           first->x.AskPosition(World::get()->cell_size, false);
           first->x.AddVector((const Vector *)&x);
-          Log() << Verbose(0) << "\n";
+          cout << Verbose(0) << "\n";
         } while (!(valid = mol->CheckBounds((const Vector *)&first->x)));
         first->type = periode->AskElement();  // give type
@@ -129,5 +129,5 @@
         valid = true;
         do {
-          if (!valid) eLog() << Verbose(2) << "Resulting position out of cell." << endl;
+          if (!valid) DoeLog(2) && (eLog()<< Verbose(2) << "Resulting position out of cell." << endl);
           second = mol->AskAtom("Enter atom number: ");
           Log() << Verbose(0) << "Enter relative coordinates." << endl;
@@ -146,7 +146,7 @@
         do {
           if (!valid) {
-            eLog() << Verbose(2) << "Resulting coordinates out of cell - " << first->x << endl;
+            DoeLog(2) && (eLog()<< Verbose(2) << "Resulting coordinates out of cell - " << first->x << endl);
           }
-          Log() << Verbose(0) << "First, we need two atoms, the first atom is the central, while the second is the outer one." << endl;
+          cout << Verbose(0) << "First, we need two atoms, the first atom is the central, while the second is the outer one." << endl;
           second = mol->AskAtom("Enter central atom: ");
           third = mol->AskAtom("Enter second atom (specifying the axis for first angle): ");
@@ -159,5 +159,5 @@
           c *= M_PI/180.;
           bound(&c, -M_PI, M_PI);
-          Log() << Verbose(0) << "radius: " << a << "\t phi: " << b*180./M_PI << "\t theta: " << c*180./M_PI << endl;
+          cout << Verbose(0) << "radius: " << a << "\t phi: " << b*180./M_PI << "\t theta: " << c*180./M_PI << endl;
 /*
           second->Output(1,1,(ofstream *)&cout);
@@ -171,5 +171,5 @@
 
           if (!z.SolveSystem(&x,&y,&n, b, c, a)) {
-            Log() << Verbose(0) << "Failure solving self-dependent linear system!" << endl;
+         coutg() << Verbose(0) << "Failure solving self-dependent linear system!" << endl;
             continue;
           }
@@ -248,7 +248,7 @@
           atoms[i] = NULL;
         int i=0, j=0;
-        Log() << Verbose(0) << "Now we need at least three molecules.\n";
+        cout << Verbose(0) << "Now we need at least three molecules.\n";
         do {
-          Log() << Verbose(0) << "Enter " << i+1 << "th atom: ";
+          cout << Verbose(0) << "Enter " << i+1 << "th atom: ";
           cin >> j;
           if (j != -1) {
@@ -265,5 +265,5 @@
         } else {
           delete first;
-          Log() << Verbose(0) << "Please enter at least two vectors!\n";
+          cout << Verbose(0) << "Please enter at least two vectors!\n";
         }
         break;
@@ -279,30 +279,30 @@
   char choice;  // menu choice char
 
-  Log() << Verbose(0) << "===========CENTER ATOMS=========================" << endl;
-  Log() << Verbose(0) << " a - on origin" << endl;
-  Log() << Verbose(0) << " b - on center of gravity" << endl;
-  Log() << Verbose(0) << " c - within box with additional boundary" << endl;
-  Log() << Verbose(0) << " d - within given simulation box" << endl;
-  Log() << Verbose(0) << "all else - go back" << endl;
-  Log() << Verbose(0) << "===============================================" << endl;
-  Log() << Verbose(0) << "INPUT: ";
+  cout << Verbose(0) << "===========CENTER ATOMS=========================" << endl;
+  cout << Verbose(0) << " a - on origin" << endl;
+  cout << Verbose(0) << " b - on center of gravity" << endl;
+  cout << Verbose(0) << " c - within box with additional boundary" << endl;
+  cout << Verbose(0) << " d - within given simulation box" << endl;
+  cout << Verbose(0) << "all else - go back" << endl;
+  cout << Verbose(0) << "===============================================" << endl;
+  cout << Verbose(0) << "INPUT: ";
   cin >> choice;
 
   switch (choice) {
     default:
-      Log() << Verbose(0) << "Not a valid choice." << endl;
+      cout << Verbose(0) << "Not a valid choice." << endl;
       break;
     case 'a':
-      Log() << Verbose(0) << "Centering atoms in config file on origin." << endl;
+      cout << Verbose(0) << "Centering atoms in config file on origin." << endl;
       mol->CenterOrigin();
       break;
     case 'b':
-      Log() << Verbose(0) << "Centering atoms in config file on center of gravity." << endl;
+      cout << Verbose(0) << "Centering atoms in config file on center of gravity." << endl;
       mol->CenterPeriodic();
       break;
     case 'c':
-      Log() << Verbose(0) << "Centering atoms in config file within given additional boundary." << endl;
+      cout << Verbose(0) << "Centering atoms in config file within given additional boundary." << endl;
       for (int i=0;i<NDIM;i++) {
-        Log() << Verbose(0) << "Enter axis " << i << " boundary: ";
+        cout << Verbose(0) << "Enter axis " << i << " boundary: ";
         cin >> y.x[i];
       }
@@ -315,7 +315,7 @@
       break;
     case 'd':
-      Log() << Verbose(1) << "Centering atoms in config file within given simulation box." << endl;
+      cout << Verbose(1) << "Centering atoms in config file within given simulation box." << endl;
       for (int i=0;i<NDIM;i++) {
-        Log() << Verbose(0) << "Enter axis " << i << " boundary: ";
+        cout << Verbose(0) << "Enter axis " << i << " boundary: ";
         cin >> x.x[i];
       }
@@ -338,12 +338,12 @@
   char choice;  // menu choice char
 
-  Log() << Verbose(0) << "===========ALIGN ATOMS=========================" << endl;
-  Log() << Verbose(0) << " a - state three atoms defining align plane" << endl;
-  Log() << Verbose(0) << " b - state alignment vector" << endl;
-  Log() << Verbose(0) << " c - state two atoms in alignment direction" << endl;
-  Log() << Verbose(0) << " d - align automatically by least square fit" << endl;
-  Log() << Verbose(0) << "all else - go back" << endl;
-  Log() << Verbose(0) << "===============================================" << endl;
-  Log() << Verbose(0) << "INPUT: ";
+  cout << Verbose(0) << "===========ALIGN ATOMS=========================" << endl;
+  cout << Verbose(0) << " a - state three atoms defining align plane" << endl;
+  cout << Verbose(0) << " b - state alignment vector" << endl;
+  cout << Verbose(0) << " c - state two atoms in alignment direction" << endl;
+  cout << Verbose(0) << " d - align automatically by least square fit" << endl;
+  cout << Verbose(0) << "all else - go back" << endl;
+  cout << Verbose(0) << "===============================================" << endl;
+  cout << Verbose(0) << "INPUT: ";
   cin >> choice;
 
@@ -358,5 +358,5 @@
       break;
     case 'b': // normal vector of mirror plane
-      Log() << Verbose(0) << "Enter normal vector of mirror plane." << endl;
+      cout << Verbose(0) << "Enter normal vector of mirror plane." << endl;
       n.AskPosition(World::get()->cell_size,0);
       n.Normalize();
@@ -378,5 +378,5 @@
         fscanf(stdin, "%3s", shorthand);
       } while ((param.type = periode->FindElement(shorthand)) == NULL);
-      Log() << Verbose(0) << "Element is " << param.type->name << endl;
+      cout << Verbose(0) << "Element is " << param.type->name << endl;
       mol->GetAlignvector(&param);
       for (int i=NDIM;i--;) {
@@ -385,5 +385,5 @@
       }
       gsl_vector_free(param.x);
-      Log() << Verbose(0) << "Offset vector: ";
+      cout << Verbose(0) << "Offset vector: ";
       x.Output();
       Log() << Verbose(0) << endl;
@@ -674,5 +674,5 @@
   Log() << Verbose(0) << "===============================================" << endl;
   if (molecules->NumberOfActiveMolecules() > 1)
-    eLog() << Verbose(2) << "There is more than one molecule active! Atoms will be added to each." << endl;
+    DoeLog(2) && (eLog()<< Verbose(2) << "There is more than one molecule active! Atoms will be added to each." << endl);
   Log() << Verbose(0) << "INPUT: ";
   cin >> choice;
@@ -830,5 +830,5 @@
   Log() << Verbose(0) << "===============================================" << endl;
   if (molecules->NumberOfActiveMolecules() > 1)
-    eLog() << Verbose(2) << "There is more than one molecule active! Atoms will be added to each." << endl;
+    DoeLog(2) && (eLog()<< Verbose(2) << "There is more than one molecule active! Atoms will be added to each." << endl);
   Log() << Verbose(0) << "INPUT: ";
   cin >> choice;
@@ -863,5 +863,5 @@
           }
           if (count != j)
-            eLog() << Verbose(1) << "AtomCount " << count << " is not equal to number of atoms in molecule " << j << "!" << endl;
+            DoeLog(1) && (eLog()<< Verbose(1) << "AtomCount " << count << " is not equal to number of atoms in molecule " << j << "!" << endl);
           x.Zero();
           y.Zero();
@@ -1208,5 +1208,5 @@
     mol = (molecules->ListOfMolecules.front())->CopyMolecule();
   else {
-    eLog() << Verbose(0) << "I don't have anything to test on ... ";
+    DoeLog(0) && (eLog()<< Verbose(0) << "I don't have anything to test on ... ");
     performCriticalExit();
     return;
@@ -1289,5 +1289,5 @@
 
   if (!strcmp(configuration->configpath, configuration->GetDefaultPath())) {
-    eLog() << Verbose(2) << "config is found under different path then stated in config file::defaultpath!" << endl;
+    DoeLog(2) && (eLog()<< Verbose(2) << "config is found under different path then stated in config file::defaultpath!" << endl);
   }
 
@@ -1393,5 +1393,5 @@
 
   if (!strcmp(configuration->configpath, configuration->GetDefaultPath())) {
-    eLog() << Verbose(2) << "config is found under different path then stated in config file::defaultpath!" << endl;
+    DoeLog(2) && (eLog()<< Verbose(2) << "config is found under different path then stated in config file::defaultpath!" << endl);
   }
 
@@ -1496,7 +1496,24 @@
             return (1);
             break;
+          case 'B':
+            if (ExitFlag == 0) ExitFlag = 1;
+            if ((argptr+5 >= argc) || (argv[argptr][0] == '-') || (!IsValidNumber(argv[argptr])) || (!IsValidNumber(argv[argptr+1])) || (!IsValidNumber(argv[argptr+2])) || (!IsValidNumber(argv[argptr+3])) || (!IsValidNumber(argv[argptr+4])) || (!IsValidNumber(argv[argptr+5])) ) {
+              ExitFlag = 255;
+              DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for bounding in box: -B <xx> <xy> <xz> <yy> <yz> <zz>" << endl);
+              performCriticalExit();
+            } else {
+              SaveFlag = true;
+              j = -1;
+              Log() << Verbose(1) << "Centering atoms in config file within given simulation box." << endl;
+              double * const cell_size = World::get()->cell_size;
+              for (int i=0;i<6;i++) {
+                cell_size[i] = atof(argv[argptr+i]);
+              }
+              argptr+=6;
+            }
+            break;
           case 'e':
             if ((argptr >= argc) || (argv[argptr][0] == '-')) {
-              eLog() << Verbose(0) << "Not enough or invalid arguments for specifying element db: -e <db file>" << endl;
+              DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments for specifying element db: -e <db file>" << endl);
               performCriticalExit();
             } else {
@@ -1508,5 +1525,5 @@
           case 'g':
             if ((argptr >= argc) || (argv[argptr][0] == '-')) {
-              eLog() << Verbose(0) << "Not enough or invalid arguments for specifying bond length table: -g <table file>" << endl;
+              DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments for specifying bond length table: -g <table file>" << endl);
               performCriticalExit();
             } else {
@@ -1605,5 +1622,5 @@
          Log() << Verbose(0) << "Bond length table loaded successfully." << endl;
        } else {
-         eLog() << Verbose(1) << "Bond length table loading failed." << endl;
+         DoeLog(1) && (eLog()<< Verbose(1) << "Bond length table loading failed." << endl);
        }
      }
@@ -1621,5 +1638,5 @@
               if ((argptr >= argc) || (argv[argptr][0] == '-')) {
                 ExitFlag = 255;
-                eLog() << Verbose(0) << "Not enough arguments for parsing: -p <xyz file>" << endl;
+                DoeLog(0) && (eLog()<< Verbose(0) << "Not enough arguments for parsing: -p <xyz file>" << endl);
                 performCriticalExit();
               } else {
@@ -1638,5 +1655,5 @@
               if ((argptr >= argc) || (argv[argptr][0] == '-') || (!IsValidNumber(argv[argptr+1])) || (!IsValidNumber(argv[argptr+2])) || (!IsValidNumber(argv[argptr+3]))) {
                 ExitFlag = 255;
-                eLog() << Verbose(0) << "Not enough or invalid arguments for adding atom: -a <element> <x> <y> <z>" << endl;
+                DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments for adding atom: -a <element> <x> <y> <z>" << endl);
                 performCriticalExit();
               } else {
@@ -1654,5 +1671,5 @@
                     configPresent = present;
                 } else
-                  eLog() << Verbose(1) << "Could not find the specified element." << endl;
+                  DoeLog(1) && (eLog()<< Verbose(1) << "Could not find the specified element." << endl);
                 argptr+=4;
               }
@@ -1667,5 +1684,5 @@
               if ((argptr >= argc) || (argv[argptr][0] == '-')) {
                 ExitFlag = 255;
-                eLog() << Verbose(0) << "Not enough or invalid arguments given for setting MPQC basis: -B <basis name>" << endl;
+                DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for setting MPQC basis: -B <basis name>" << endl);
                 performCriticalExit();
               } else {
